﻿using System.Drawing;
using NTERA.Core.Interop;

namespace NTERA.Core
{
	public interface IConsole
	{
        string LastInput { get; }

        InputRequest CurrentRequest { get; }
		void GiveInput(string input);

		void PrintError(string message);
		void PrintSystemLine(string message);
		void DebugClearTraceLog();
		void DebugAddTraceLog(string message);
		void DebugRemoveTraceLog();
		bool RunERBFromMemory { get; }
		void PrintWarning(string message, int level);
		void setStBar(string bar);
		void ReadAnyKey();
		void WaitInput(InputRequest request);
		void ResetStyle();
		void OutputLog(string log);
		bool noOutputLog { get; set; }
		void ThrowTitleError(bool something);
		void PrintBar();
		void PrintSingleLine(string line, bool temporary = false);
		void NewLine();
		void RefreshStrings(bool something);
		void SetWindowTitle(string title);
		bool IsRunning { get; }
		bool Enabled { get; }
		void ThrowError(bool playSound);
		void PrintErrorButton(string message);
		void Write(string message);
		bool UseSetColorStyle { get; set; }
		void PrintC(string message, bool something);
		DisplayLineAlignment Alignment { get; set; }
		void deleteLine(int line);
		void PrintTemporaryLine(string line);
		bool updatedGeneration { get; set; }
		void PrintFlush(bool something);
		bool LastLineIsTemporary { get; }
		bool LastLineIsEmpty { get; }
		void ReloadErbFinished();
		bool MesSkip { get; }
		//StringStyle StringStyle { get; set; }
		Color bgColor { get; set; }
		ConsoleRedraw Redraw { get; set; }
		bool EmptyLine { get; }
		string getStBar(string something);
		void PrintButton(string something, long something1);
		void PrintButton(string something, string something1);
		void PrintButtonC(string something, long something1, bool something2);
		void PrintButtonC(string something, string something1, bool something2);
		void PrintPlain(string message);
		void printCustomBar(string bar);
		bool UseUserStyle { get; set; }
		void Quit();
		void PrintHtml(string html, bool newline);
		void PrintImg(string img);
		void PrintShape(string shape, int[] param);
		void DebugPrint(string message);
		void DebugNewLine();
		void DebugClear();
		void ReadAnyKey(bool something, bool something2);
		void SetStringStyle(Color color);
		void SetStringStyle(FontStyle fontStyle);
		void SetBgColor(Color color);
		void SetToolTipColor(Color fc, Color bc);
		void SetToolTipDelay(int delay);
		void SetToolTipDuration(int duration);
		void SetFont(string font);
		void SetRedraw(long value);
		int NewButtonGeneration { get; }
		void UpdateGeneration();
		string GetWindowTitle();
		long LineCount { get; }
		string getDefStBar();
		bool IsTimeOut { get; }
	}
}