﻿using System.IO;
using NTERA.Core;
using NTERA.EmuEra.Game;
using NTERA.EmuEra.Game.EraEmu.Content;
using NTERA.EmuEra.Game.EraEmu.GameProc;

namespace NTERA.EmuEra
{
	public class EmuEraGameInstance : IScriptEngine
	{
		private Process emuera;

		public bool Initialize(IConsole console)
		{
			emuera = new Process(console);

			GlobalStatic.Process = emuera;
			GlobalStatic.Console = console;

			Program.CMain(Directory.GetCurrentDirectory() + "\\");

			return emuera.Initialize();
		}

		public void Start()
		{
			emuera.DoScript();
		}

		public void InputString(string input)
		{
			emuera.InputString(input);
		}

		public void InputInteger(long input)
		{
			emuera.InputInteger(input);
		}

		public void InputSystemInteger(long input)
		{
			emuera.InputSystemInteger(input);
		}

		public CroppedImage GetImage(string name)
		{
			return AppContents.GetContent(name);
		}
	}
}
