﻿using System;
using System.Windows.Forms;

namespace NTERA.Console
{
	public partial class ConsoleControl : UserControl
	{
		public readonly ConsoleRenderer Renderer = new ConsoleRenderer();
		
		public ConsoleControl()
		{
			InitializeComponent();

	//		Renderer.Items.Add(new TextRenderItem("Sia - Chandelier (Alternative♂Version)"));
	//		Renderer.Items.Add(new TextRenderItem("【本格的LatinPop】Livin' la Mara Loca - 嗶哩嗶哩 - ( ゜- ゜)つロ 乾杯~."));
	//		Renderer.Items.Add(new ButtonTextRenderItem("-- fisting is $300", new[] { new CharacterRange(3, 7) }));
	//		Renderer.Items.AddRange(ImageRenderItem.CreateFromLargeBitmap(new Bitmap(@"B:\we gotta find the princess.PNG"), Renderer.LineHeight));
	//		Renderer.Items.AddRange(TextRenderItem.CreateFromLinedText(@"Dear Pesky Plumbers,
	//The Koopalings and I have taken over the Mushroom Kingdom.
	//The Princess is now a permanent guest at one of my seven Koopa Hotels.
	//I dare you to find her, if you can!
	//- Bowser"));
			
			displayPanel.MouseWheel += (sender, args) => //this adds scrolling capability to the panel, so you can scroll on it
			{
				int oldValue = offsetScrollBar.Value;
				int trueMaximum = Math.Max(1, (1 + offsetScrollBar.Maximum) - offsetScrollBar.LargeChange);

				offsetScrollBar.Value = Math.Min(offsetScrollBar.Maximum - 1, Math.Max(0, Math.Min(offsetScrollBar.Value, trueMaximum) + (offsetScrollBar.SmallChange * args.Delta / -120)));
				
				offsetScrollBar_Scroll(null, new ScrollEventArgs(ScrollEventType.SmallDecrement, oldValue, offsetScrollBar.Value));
			};

			Renderer.AddedItem += (item) =>
			{
				if (InvokeRequired)
				{
					Invoke(new MethodInvoker(() => Invalidate(true)));
				}
				else
				{
					Invalidate(true);
				}
			};
		}

		protected override void OnResize(EventArgs e)
		{
			base.OnResize(e);

			Invalidate(ClientRectangle, true);
		}

		private void displayPanel_Paint(object sender, PaintEventArgs e)
		{
			int lineCount = Renderer.Render(e.Graphics, displayPanel.ClientRectangle, displayPanel.ClientRectangle, PointToClient(MousePosition)); //this is the only code in this method related to rendering. everything else is because MS fucked up what ScrollBar.Maximum actually is
		}

		private void displayPanel_MouseMove(object sender, MouseEventArgs e)
		{
			Renderer.MouseHoverEvent(e.Location, this);
		}

		private void displayPanel_Resize(object sender, EventArgs e)
		{
			base.OnResize(e);

			Invalidate();
		}
		
		private void offsetScrollBar_Scroll(object sender, ScrollEventArgs e)
		{
			if (e.NewValue != e.OldValue)
			{
				int trueMaximum = Math.Max(1, (1 + offsetScrollBar.Maximum) - offsetScrollBar.LargeChange);

				int newOffset = Math.Max(0, trueMaximum - offsetScrollBar.Value);

				if (newOffset == Renderer.offset)
					return;

				Renderer.offset = newOffset;

				Invalidate(ClientRectangle, true);

				offsetScrollBar.Maximum = (Renderer.LastLineCount - 1) + offsetScrollBar.LargeChange;
			}
		}
	}
}