﻿using System.Drawing;
using System.Windows.Forms;

namespace NTERA.Console.RenderItem
{
	public class ButtonTextRenderItem : BaseRenderItem
	{
		public static Font Font { get; set; } = new Font("MS UI Gothic", 12); //new Font("Arial", 12);

		public static SolidBrush TextBrush = new SolidBrush(Color.White);

		public static SolidBrush SelectedBrush = new SolidBrush(Color.Yellow);

		public string Text { get; set; }

		public override bool InvalidateOnMouseStateChange => true;

		public ButtonTextRenderItem(string text)
		{
			Text = text.Replace("　", "  ");
		}

		public override int Render(Graphics graphics, Rectangle renderArea, Rectangle invalidatedArea, Point mousePointer)
		{
			//graphics.DrawString(Text, Font, TextBrush, renderArea);

			//return (int)graphics.MeasureString(Text, Font).Width + renderArea.X;

			TextRenderer.DrawText(graphics, Text, Font, renderArea.Location, TextBrush.Color, TextFormatFlags.ExternalLeading);

			return TextRenderer.MeasureText(graphics, Text, Font).Width + renderArea.X;
		}
	}
}