﻿using System.Threading.Tasks;
using System.Windows.Forms;
using NTERA.Console;
using NTERA.Core;
using NTERA.EmuEra;
using NTERA.Interpreter;

namespace NTERA
{
	public partial class formMain : Form
	{
		private readonly GameInstance instance = new GameInstance();

		public formMain()
		{
			InitializeComponent();

            //var scriptEngine = new EmuEraGameInstance();
            var scriptEngine = new Engine();

            Task.Factory.StartNew(() => instance.Run(new EraConsoleInstance(consoleControl1.Renderer, scriptEngine), scriptEngine));
		}

		private void txtInput_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Enter)
			{
				instance.GiveInput(txtInput.Text);
				txtInput.Text = "";

				e.Handled = true;
				e.SuppressKeyPress = true;
			}
		}
	}
}